#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>

using namespace std;

struct Field{
	int field[50][50];
	int N,K;
	int animalsCount;
};

struct Animal{
	int form[10][10];
	int N,K;
	int reduceBy;
	int minAcceptance;
	int id;

	double formDensity;
	double weight;

	bool operator<(const Animal& other){
		return  weight > other.weight;
	}
};

struct SolutionItem{
	int animal;
	int x,y;
	int gain;
	int lost;
	int weight;

	bool operator<(const SolutionItem& other){
		return  gain > other.gain;
	}
};

Field field;
Animal animals[100];

#if 1
#define cin filein
#define cout fileout
#endif

SolutionItem findBestPosition(int i)
{
	SolutionItem item;
	item.animal = animals[i].id;
	item.gain = -1;
	item.lost = -1;
	item.weight = -10000000;
	for(int x = 0; x <= field.N - animals[i].N; x++){
		for(int y = 0; y <= field.K - animals[i].K;y++){
			int total_gain = 0;
			int total_lost = 0;
			for(int n = 0; n < animals[i].N; n++){
				for(int k = 0; k < animals[i].K; k++){
					if ( field.field[x+n][y+k] < animals[i].minAcceptance ){
						goto next;
					}
					total_gain += animals[i].form[n][k]*field.field[x+n][y+k];
					total_lost += animals[i].form[n][k]*field.field[x+n][y+k] - (animals[i].form[n][k]*field.field[x+n][y+k]  / animals[i].reduceBy);
				}
			}
			if ( (total_gain-total_lost) > item.weight ){
				item.gain = total_gain;
				item.lost = total_lost;
				item.x = x;
				item.y = y;
			}
		next: ;
		}
	}

	return item;
}

struct Vertex
{
	int animalIndex;
	int x,y;
};

void main()
{
	ifstream filein("parash.in");
	ofstream fileout("parash.out");
	// Read data
	cin >> field.N >> field.K >> field.animalsCount;
	for(int i = 0; i < field.N; i++){
		for(int j = 0; j < field.K;j++){
			cin >> field.field[i][j];
		}
	}

	for(int i = 0; i < field.animalsCount; i++){
		cin >> animals[i].N >> animals[i].K >> animals[i].reduceBy >> animals[i].minAcceptance;
		animals[i].formDensity = 0;
		animals[i].id = i;
		for(int n = 0; n < animals[i].N; n++){
			for(int k = 0; k < animals[i].K; k++){
				char c;
				cin >> c;
				animals[i].form[n][k] = (int)c - 48;
				animals[i].formDensity += animals[i].form[n][k];
			}
		}
	}

	// Solve
	vector<SolutionItem> solution;

	// Precompute weights
	for(int animal = 0; animal < field.animalsCount; animal++){
		animals[animal].weight = animals[animal].formDensity / animals[animal].reduceBy;
	}

	sort(animals, animals + field.animalsCount);

	// Greedy naximize the effeciency of each jump in the sequence
	for(int i = 0; i < field.animalsCount; i++){
		std::vector<SolutionItem> items;
		//SolutionItem item;
		//item.animal = animals[i].id;
		//item.gain = -1;
		for(int x = 0; x <= field.N - animals[i].N; x++){
			for(int y = 0; y <= field.K - animals[i].K;y++){
				int total_gain = 0;
				for(int n = 0; n < animals[i].N; n++){
					for(int k = 0; k < animals[i].K; k++){
						if ( field.field[x+n][y+k] < animals[i].minAcceptance ){
							goto next;
						}
						total_gain += animals[i].form[n][k]*field.field[x+n][y+k];
						SolutionItem item;

						item.animal = animals[i].id;
						item.gain = total_gain;
						item.x = x;
						item.y = y;

						items.push_back(item);
					}
				}

				//if ( total_gain > item.gain ){
				//	item.gain = total_gain;
				//	item.x = x;
				//	item.y = y;
				//}
next: ;
			}
		}

		std::sort( items.begin(), items.end());

		if ( items.size() > 0 ){
			SolutionItem item = items[ 0 ];
			solution.push_back(item);
			for(int n = 0; n < animals[i].N; n++){
				for(int k = 0; k < animals[i].K; k++){
					field.field[item.x+n][item.y+k] /= animals[i].reduceBy;
				}
			}
		}

		//if ( item.gain != -1){
		//	solution.push_back(item);
		//	for(int n = 0; n < animals[i].N; n++){
		//		for(int k = 0; k < animals[i].K; k++){
		//			field.field[item.x+n][item.y+k] /= animals[i].reduceBy;
		//		}
		//	}
		//}
	}

	// Write solution
	cout << solution.size() << endl;

	int total = 0;
	for(int i = 0; i < solution.size(); i++){
		cout << solution[i].animal + 1 << " " << solution[i].x + 1 << " " << solution[i].y + 1 << endl;
		total += solution[i].gain;
	}
	//cout << total <<  endl;
	//cout << field.animalsCount - solution.size()  << endl;
}

